/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/


/*

	<H323Define.h>	2004-07-03,12:02

*/

#ifndef __2004_07_03__12_02__H323DEFINE_H__
#define __2004_07_03__12_02__H323DEFINE_H__


#if 0
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <string.h>
#else
#include "HSDefine.h"
#include "HSBase.h"
#endif





/***********************/
/* Compile Definitions
 */
#undef  HS_CPLUSPLUS
#define HS_DEBUG_ASN
#define HS_DEBUG_ASN_MEMBER
#define HS_DEBUG_ASN_PRINT



	

#define HS_NULL						NULL
	
#define	HS_ASCII_SIZE				256
#define HS_MAX_DIGIT				256
#define HS_MAX_LETTER				256
#define HS_MAX_ENUMERATED			256
#define HS_ASN_MAX_EXTENSION_OCTET	512





/* warning protection
 */
#if defined(_WIN32) || defined(_WIN32_WCE)
#define HS_ASN_MAX_CONSTRAINT		4294967295
#elif defined(_LINUX) || defined(_VXWORKS)
#define HS_ASN_MAX_CONSTRAINT		0xffffffff
#endif





#define HS_ERR_ASN							HS_ERR+100
#define HS_ERR_ASN_STREAM_OVERFLOW			HS_ERR_ASN+1
#define HS_ERR_ASN_LENGTH					HS_ERR_ASN+2
#define HS_ERR_ASN_NOCHOICE					HS_ERR_ASN+3
#define HS_ERR_ASN_OUTOF_RANGE				HS_ERR_ASN+4
#define HS_ERR_ASN_CONFLICT					HS_ERR_ASN+5
#define HS_ERR_ASN_NO_MOLD					HS_ERR_ASN+6
#define HS_ERR_ASN_NOUSEYET					HS_ERR_ASN+7
#define HS_ERR_ASN_ENUMFULL					HS_ERR_ASN+8





/* some headers file on vxworks use m_data and m_type with '#define'
 * follow definitions erase it
 */
#if defined(_VXWORKS)
#ifdef m_data
#undef m_data
#endif
#ifdef m_type
#undef m_type
#endif
#endif





#endif/*__2004_07_03__12_02__H323DEFINE_H__*/


