/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/


/*

	<CallClose.h>	2005-04-17,09:56

*/

#ifndef __2005_04_17__09_56__CALLCLOSE_H__
#define __2005_04_17__09_56__CALLCLOSE_H__



#include "H323Define.h"
#include "EpDefine.h"
#include "RasMessageMaker.h"



/* close H.245 channel,
   disengage admission,
   close Q.931 channel,
   CallbackRemoveCall,
   RMOVE_SOCKET_SET
*/
HS_RESULT CallClosing(
	StackInfo *pStack,
	IEndpoint *pEndpoint,
	NoLockList *pCalls,
	NoLockList *pWaits,
	ICall *pCall,
	CallCloseReason	pUserReason,
	ASNH225DisengageReasonChoice pDisReason,
	Q931CauseType pCause
);

HS_RESULT ReleaseControlChannel(StackInfo *pStack, IEndpoint *pEndpoint, ICall *pCall );
HS_RESULT ReleaseAdmission(StackInfo *pStack, IEndpoint *pEndpoint, ICall *pCall, NoLockList *pWaits, ASNH225DisengageReasonChoice pReason );
HS_RESULT ReleaseSignalChannel(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall, Q931CauseType pCause );



#endif/*__2005_04_17__09_56__CALLCLOSE_H__*/


