/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/

/*

	<iGatekeeper.h>		2005-03-13,14:39

*/

#ifndef __2005_03_13__14_39__IGATEKEEPER_H__
#define __2005_03_13__14_39__IGATEKEEPER_H__



#include "H323Define.h"
#include "EpDefine.h"
#include "H323Utility.h"



typedef struct
{
	char target[256];
	BOOL registed;
	/* user can remove registration in TRY STATE(sent GRQ or RRQ and wait GXX or RXX)
	   we must remove #RasWaitSet# immediately, so we need to remember requestSeqNum of GRQ or RRQ
	   #sn# variable remember it.
	*/
	HS_USHORT sn;
} Registrar;
HS_RESULT new_Registrar( Registrar *pObj );
HS_RESULT delete_Registrar( Registrar *pObj );



typedef struct
{
	ASNH225EndpointIdentifier endpointIdentifier;
	ASNH225GatekeeperIdentifier gatekeeperIdentifier;

	Registrar	*registrar;

	BOOL	isGRQ;
	BOOL	isUseLightRRQ;

	HS_UINT attemptTime;
	HS_UINT ttl;
	BOOL	ttlForce;
} IGatekeeper;

HS_RESULT new_IGatekeeper( IGatekeeper *pObj );
HS_RESULT delete_IGatekeeper( IGatekeeper *pObj );
BOOL IGatekeeper_IsRegisted( IGatekeeper *pObj );



#endif/*__2005_03_13__14_39__IGATEKEEPER_H__*/


