/*--------------------------------------------------------------------------------*
 *                                                                                *
 * This material is strictly confidential and shall remain as such.               *
 *                                                                                *
 * Copyright  2004 - VoiceAge Corporation. All Rights Reserved. No part of this  *
 * material may be reproduced, stored in a retrieval system, or transmitted, in   *
 * any form or by any means: photocopying, electronic, mechanical, recording, or  *
 * otherwise, without the prior written permission of the copyright holder.       *
 *                                                                                *
 * This material is subject to continuous developments and improvements. All      *
 * warranties implied or expressed, including but not limited to implied          *
 * warranties of merchantability, or fitness for purpose, are excluded.           *
 *                                                                                *
 * ACELP is registered trademark of VoiceAge Corporation in Canada and / or other *
 * countries. Any unauthorized use is strictly prohibited.                        *
 *                                                                                *
 *--------------------------------------------------------------------------------*/

//--------------------------------------------------------------------------------
//  System or OS dependent functions; if different/unsupported, then rewrite 
//  on your target platform.
//--------------------------------------------------------------------------------

#ifndef _OS_DEPEND_F
#define _OS_DEPEND_F

#include <stdio.h>

#ifdef __cplusplus
extern "C"  {
#endif

void VA_printf( char *fmt, ...);
void *VA_malloc(size_t n);
void VA_free(void *ptr);
void *VA_realloc(void *ptr,size_t n);
void *VA_memcpy(void *ptr1, const void *ptr2, size_t n);
void *VA_memset(void *ptr, int i, size_t n);
void *VA_calloc(size_t n, size_t t);
void VA_fatal_error(int ec);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif //_OS_DEPEND_F
