/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/

/*

	<SipUtility.h>		2005-10-18,22:06

*/

#ifndef __2005_10_18__22_06__SIPUTILITY_H__
#define __2005_10_18__22_06__SIPUTILITY_H__

#include "SipDefine.h"
#include "UaDefine.h"
#include "ITransaction.h"





HS_RESULT SipRecordRoutes2SipRoutes(NoLockList *pTo, NoLockList *pFrom);





/* copy functions
*/
HS_RESULT SipUri_Copy(SipUri *pTo, SipUri *pFrom);
HS_RESULT SipVias_Copy(NoLockList *pTo, NoLockList *pFrom);
HS_RESULT SipRoutes_Copy(NoLockList *pTo, NoLockList *pFrom);
HS_RESULT SipContacts_Copy(NoLockList *pTo, NoLockList *pFrom);
HS_RESULT SipAuthorization_Copy(SipAuthorization *pTo, SipAuthorization *pFrom);





/* clone functions
*/
typedef enum
{
	e_AuthType_Request,
	e_AuthType_Response,
	e_AuthType_ProxyRequest,
	e_AuthType_ProxyResponse
} AuthType;

SipAuthorization *SipAuthorization_Clone(SipAuthorization *pObj, AuthType pType);





/* etc
*/
HS_RESULT RegulatingCopiedVia(NoLockList *pVias);





#endif/*__2005_10_18__22_06__SIPUTILITY_H__*/


