/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/

/*

	<UaDefine.h>	2005-10-22,21:24

*/

#ifndef __2005_10_22__21_24__UADEFINE_H__
#define __2005_10_22__21_24__UADEFINE_H__



#include "SipDefine.h"
#include "SipMessage.h"
#include "SipSdp.h"



#define HS_OS_WINDOWS



#ifdef HS_OS_WINDOWS

#if defined(_WIN32) || (_WIN32_WCE)
	#undef BOOL

	#ifdef _WIN32_WCE
		#include <wce.h>
	#else
		#include <windows.h>
		#include <process.h>
	#endif
#endif

	#define HS_TID_SIP				WM_USER+2000
	#define HS_TID_SIP_TIMER_T1		HS_TID_SIP+1
	#define HS_TID_SIP_TIMER_T2		HS_TID_SIP+2
	#define HS_TID_SIP_TIMER_T4		HS_TID_SIP+3
	#define HS_TID_SIP_TIMER_A		HS_TID_SIP+4
	#define HS_TID_SIP_TIMER_B		HS_TID_SIP+5
	#define HS_TID_SIP_TIMER_C		HS_TID_SIP+6
	#define HS_TID_SIP_TIMER_D		HS_TID_SIP+7
	#define HS_TID_SIP_TIMER_E		HS_TID_SIP+8
	#define HS_TID_SIP_TIMER_F		HS_TID_SIP+9
	#define HS_TID_SIP_TIMER_G		HS_TID_SIP+10
	#define HS_TID_SIP_TIMER_H		HS_TID_SIP+11
	#define HS_TID_SIP_TIMER_I		HS_TID_SIP+12
	#define HS_TID_SIP_TIMER_J		HS_TID_SIP+13
	#define HS_TID_SIP_TIMER_K		HS_TID_SIP+14
	#define HS_TID_SIP_TIMER_MAX	HS_TID_SIP_TIMER_K+1
	#define HS_TID_SIP_REGISTER		HS_TID_SIP_TIMER_MAX

#if defined(_WIN32) || (_WIN32_WCE)
	#define HSSemaphore				CRITICAL_SECTION
	#define HSOpenSemaphore(sem)	InitializeCriticalSection(&sem)
	#define HSCloseSemaphore(sem)	DeleteCriticalSection(&sem)
	#define HSLockSemaphore(sem)	EnterCriticalSection(&sem)
	#define HSUnlockSemaphore(sem)	LeaveCriticalSection(&sem)
#endif

#endif/*HS_OS_WINDOWS*/




#define HS_SIP_TTL_MARGIN	2





#endif/*__2005_10_22__21_24__UADEFINE_H__*/


